#-----------------------------------------------------------------------------
#global		rcnum		rc8
%{?!dist:	%define		dist	.ok}
%global		ksrcver		%(cat /etc/kernel-devel)
%if "%{ksrcver}" == ""
%global ksrcver	%(uname -r)}
%endif
%global		sourcelink	/usr/src/kernels/%{ksrcver}
%global		__python	/usr/bin/python3
#-----------------------------------------------------------------------------
Name		:	zfs
Version		:	2.1.12%{?rcnum:.%{rcnum}}
Release		:	14.4.0.0%{?dist}
Summary		:	Native ZFS for Linux
Group		:	Utilities/system

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	CDDL open source license
URL		:	https://github.com/zfsonlinux/zfs/releases

Source0		:	%{name}-2.1.12%{?rcnum:-%{rcnum}}.tar.gz
Source1		:	%{name}-ok_addon.tar.gz

#-----------------------------------------------------------------------------
BuildRequires	:	eudev-devel
BuildRequires	:	linux-devel 
BuildRequires	:	%{__python}
BuildRequires	:	osukiss-release
BuildRequires	:	pam-devel

Requires	:	%{name}-kmod	=	%{version}-%{release}
Requires	:	pam

Obsoletes	:	spl  <= %{version}
#-----------------------------------------------------------------------------
%description
ZFS on Linux is an advanced file system and volume manager which was originally
developed for Solaris and is now maintained by the OpenZFS community.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root, -)
%doc AUTHORS COPYRIGHT NEWS README.md
/sbin/mount.%{name}
%{_sysconfdir}/init.d/%{name}-*
%{_sysconfdir}/cron.d/%{name}.cron
%{_sysconfdir}/%{name}/vdev*.example
%{_sysconfdir}/%{name}/zed.d/*.sh
%{_sysconfdir}/%{name}/zed.d/zed.rc
%{_sysconfdir}/%{name}/%{name}-functions
%{_sysconfdir}/%{name}/zpool.d/*
%{_sysconfdir}/sudoers.d/%{name}
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%config(noreplace) %{_sysconfdir}/modprobe.d/%{name}.conf
%{_bindir}/arc_summary
%{_bindir}/arcstat
%{_bindir}/dbufstat
%{_bindir}/raidz_test
%{_bindir}/zvol_wait
%{_sbindir}/fsck.%{name}
%{_sbindir}/%{name}
%{_sbindir}/%{name}-trim
%{_sbindir}/%{name}-scrub
%{_sbindir}/zdb
%{_sbindir}/zed
%{_sbindir}/zfs_ids_to_path
%{_sbindir}/zhack
%{_sbindir}/zgenhostid
%{_sbindir}/zinject
%{_sbindir}/zpool
%{_sbindir}/zstream
%{_sbindir}/zstreamdump
%{_sbindir}/ztest
%{_libexecdir}/%{name}/zpool.d/*
%{_libexecdir}/%{name}/zed.d/*
%{_libexecdir}/%{name}/zpool_influxdb
%{_libdir}/udev/rules.d/60-zvol.rules
%{_libdir}/udev/rules.d/69-vdev.rules
%{_libdir}/udev/rules.d/90-%{name}.rules
%{_libdir}/udev/vdev_id
%{_libdir}/udev/zvol_id
%{_libdir}/lib*.so.*
%{_libdir}/security/pam_%{name}_key.so
%{_prefix}/lib/dracut/modules.d/*
%{_datadir}/initramfs-tools/*
%{_datadir}/pam-configs/%{name}_key
%{_mandir}/man1/*.1.gz
%{_mandir}/man8/*.8.gz

#-----------------------------------------------------------------------------
%preun
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{name}-zed stop > /dev/null 2>&1 || :
  %{_sysconfdir}/rc.d/init.d/%{name}-mount stop > /dev/null 2>&1 || :
  /sbin/chkconfig --del %{name}-share
  /sbin/chkconfig --del %{name}-zed
  /sbin/chkconfig --del %{name}-mount
  /sbin/chkconfig --del %{name}-import
  fi
/usr/sbin/ldconfig

%post
/usr/sbin/ldconfig
/sbin/chkconfig --add %{name}-import
%{_sysconfdir}/rc.d/init.d/%{name} start > /dev/null 2>&1 || :
/sbin/chkconfig --add %{name}-mount
%{_sysconfdir}/rc.d/init.d/%{name} start > /dev/null 2>&1 || :
/sbin/chkconfig --add %{name}-zed
%{_sysconfdir}/rc.d/init.d/%{name} start > /dev/null 2>&1 || :
/sbin/chkconfig --add %{name}-share
%{_sysconfdir}/rc.d/init.d/%{name} start > /dev/null 2>&1 || :


#=============================================================================
%package		kmod

Summary		:	%{name} kernel module(s)

Requires	:	linux		=	%{ksrcver}

Requires	:	kmod
Requires	:	kernel-modules	=	%{ksrcver}

Provides	:	multiversion(kernel)
#-----------------------------------------------------------------------------
%description		kmod
This package contains the ZFS kernel modules.

#-----------------------------------------------------------------------------
%files			kmod
%defattr(-,root,root, -)
/lib/modules/%{ksrcver}/extra/avl/zavl.ko
/lib/modules/%{ksrcver}/extra/icp/icp.ko
/lib/modules/%{ksrcver}/extra/lua/zlua.ko
/lib/modules/%{ksrcver}/extra/nvpair/znvpair.ko
/lib/modules/%{ksrcver}/extra/spl/spl.ko
/lib/modules/%{ksrcver}/extra/unicode/zunicode.ko
/lib/modules/%{ksrcver}/extra/zcommon/zcommon.ko
/lib/modules/%{ksrcver}/extra/zstd/zzstd.ko
/lib/modules/%{ksrcver}/extra/%{name}/%{name}.ko

#-----------------------------------------------------------------------------
%postun			kmod

%post			kmod
depmod -a %{ksrcver}

#=============================================================================
%package kmod-devel

Summary		:	%{name} kernel module(s) devel common

#-----------------------------------------------------------------------------
%description kmod-devel
This package provides the header files and objects to build kernel modules.

#-----------------------------------------------------------------------------
%files	kmod-devel
%defattr(-,root,root, -)
%{_prefix}/src/%{name}-2.1.12/*
%{_prefix}/src/spl-2.1.12/*
%{_mandir}/man5/*.5.gz

#=============================================================================
%package		devel

Summary		:	Development headers

#-----------------------------------------------------------------------------
Requires	:       %{name} = %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
This package contains the header files needed for building additional
applications against the ZFS libraries.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root, -)
%{_includedir}/libspl/*.h
%{_includedir}/libspl/sys/*.h
%{_includedir}/libspl/sys/*/*.h
%{_includedir}/libspl/rpc/*.h
%{_includedir}/libspl/ia32/sys/asm_linkage.h
%{_includedir}/lib%{name}/sys/*.h
%{_includedir}/lib%{name}/sys/crypto/*.h
%{_includedir}/lib%{name}/sys/fm/fs/*.h
%{_includedir}/lib%{name}/sys/fm/*.h
%{_includedir}/lib%{name}/sys/fs/%{name}.h
%{_includedir}/lib%{name}/sys/sysevent/dev.h
%{_includedir}/lib%{name}/sys/sysevent/eventdefs.h
%{_includedir}/lib%{name}/sys/zstd/zstd.h
%{_includedir}/lib%{name}/sys/lua/lua*.h
%{_includedir}/lib%{name}/sys/lua/lauxlib.h
%{_includedir}/lib%{name}/*.h
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/lib%{name}*.pc
%{_mandir}/man4/*.4.gz
%{_mandir}/man7/*.7.gz

#=============================================================================
%package tests

Summary		:	%{name} Test infrastructure

#-----------------------------------------------------------------------------
Requires	:       %{name} = %{version}-%{release}
Requires	:       parted
Requires	:       mdadm
Requires	:       bc
Requires	:       ksh
Requires	:       acl
Requires	:       sudo

#-----------------------------------------------------------------------------
%description tests
This package contains test infrastructure and support scripts for
validating the file system.

#-----------------------------------------------------------------------------
%files	tests
%defattr(-,root,root, -)
%{_datadir}/%{name}/*.sh
%{_datadir}/%{name}/runfiles/*
%{_datadir}/%{name}/test-runner/bin/*.py
%{_datadir}/%{name}/test-runner/include/*.shlib
%{_datadir}/%{name}/zfs-tests/*
%{_datadir}/%{name}/compatibility.d/*


#=============================================================================
%prep
%setup -q -n %{name}-%{version}

#-----------------------------------------------------------------------------
#building application
%build
tar xf %{SOURCE1}

./autogen.sh
./configure						\
        --prefix=%{_prefix}				\
	--libdir=%{_libdir}				\
        --includedir=%{_includedir}			\
	--exec-prefix=%{_exec_prefix}			\
	--libexecdir=%{_libexecdir}			\
        --sysconfdir=%{_sysconfdir}			\
        --bindir=%{_bindir}				\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--infodir=%{_infodir}				\
	--datadir=%{_datadir}				\
	--docdir=%{_defaultdocdir}/%{name}-2.1.12	\
	--localedir=%{_prefix}				\
	--disable-pyzfs					\
	--disable-static				\
	--disable-systemd				\
	--enable-sysvinit				\
	--with-config=all				\
	--with-udevdir=%{_libdir}/udev/			\
	--with-python=%{__python}			\
	--with-linux=%{sourcelink}			\
	--with-linux-obj=%{sourcelink}			\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} %{_smp_mflags}

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make}						\
	DESTDIR=%{buildroot}				\
	install

#To remove libtool library
find 							\
	%{buildroot}%{_libdir}				\
	-name \*.la					\
	-delete

%{__cp} -a						\
	%{name}-ok_addon/%{name}-import			\
	%{name}-ok_addon/%{name}-mount			\
	%{name}-ok_addon/%{name}-zed			\
	%{name}-ok_addon/%{name}-share			\
	%{buildroot}%{_sysconfdir}/init.d

%{__cp} -a						\
	%{name}-ok_addon/%{name}-trim			\
	%{name}-ok_addon/%{name}-scrub			\
	%{buildroot}%{_sbindir}

#Adding zfs module parameters setup
%{__mkdir_p} %{buildroot}%{_sysconfdir}/modprobe.d/
%{__cp} -a						\
	%{name}-ok_addon/module_%{name}.conf		\
	%{buildroot}%{_sysconfdir}/modprobe.d/%{name}.conf

#adding cron directive
%{__mkdir_p}						\
	%{buildroot}%{_sysconfdir}/cron.d
%{__cp} 						\
	-a						\
	%{name}-ok_addon/%{name}.cron			\
	%{buildroot}%{_sysconfdir}/cron.d/%{name}.cron

cat							\
	%{name}-ok_addon/%{name}_delay		>>	\
	%{buildroot}%{_sysconfdir}/sysconfig/%{name}
	
	
#-----------------------------------------------------------------------------
%changelog
